import { Component, OnInit, TemplateRef } from '@angular/core';
import { FormGroup, Validators, FormBuilder } from '@angular/forms';
import { BsModalRef, ModalOptions, BsModalService } from 'ngx-bootstrap';
import { Router } from '@angular/router';
import { CommondialogComponent } from 'src/app/Shared/commondialog/commondialog.component';
import { ToastrService } from 'ngx-toastr';
import { DialogService } from 'ng2-bootstrap-modal';
import { AllocationType } from './allocationtype';
import { AllocationtypeService } from './allocationtype.service';

@Component({
  selector: 'app-allocationtype',
  templateUrl: './allocationtype.component.html',
  styleUrls: ['./allocationtype.component.css']
})
export class AllocationtypeComponent implements OnInit {
  sendMenuId: number;
  sendPageName = 'AllocationType';
  // action rights
  _menuId: any;
  _actionRights: any;
  readOnly = false; add = false; edit = false; delete = false;
  allocationtypeForm: FormGroup;
  allocationtypes: AllocationType[] = [];
  allocationtypesactive: AllocationType[] = [];
  allocationtype: AllocationType;
  deleteResult: boolean;
  postresult: boolean;
  putDResult: boolean;
  allocationtypeModalRef: BsModalRef;
  operation: string;
  userid: number;
  allocationtypeid: number;
  submitted = false;
  active: number;
  unamePattern: string;
  confmsg: string;
  p = 1; searchText: string;
  itemsPerPage = 10;
  config: ModalOptions = {
    backdrop: 'static',
    keyboard: false,
    animated: true,
    class: 'modal-dialog-centered',
    ignoreBackdropClick: true
  };
  showall = true;
  showallstatus = false;
  key = 'allocationtype'; // set default
  reverse = false;
  actionRights: any;
  constructor(private router: Router, private toastr: ToastrService, private dialogService: DialogService,
    private formBuilder: FormBuilder, private modalService: BsModalService, private allocationtypeservice: AllocationtypeService) {
     // get rights for the logged in user for the particular component
     if (this.router.getCurrentNavigation().extras.state !== undefined) {
      localStorage.setItem('AllocationType_menuid', this.router.getCurrentNavigation().extras.state.menuid);
      localStorage.setItem('AllocationType_userRights', this.router.getCurrentNavigation().extras.state.action);
      this.actionRights = [];
      this.actionRights = this.router.getCurrentNavigation().extras.state.action;
    } else {
      this.actionRights = [];
      this.actionRights = localStorage.getItem('AllocationType_userRights');
    }
  }

  ngOnInit() {
    this.allocationtypeForm = this.formBuilder.group({
      allocationtypeid: [''],
      allocationtype: ['', [Validators.required]],
      active: ['']
    });
    this.searchText = '';
    this.getAll();
    // for action rights
    this.getUserRights();
  }

  getactiveinactive(showallp) {
    this.allocationtypesactive = [];
    this.showall = showallp;
    this.showallstatus = showallp;
    if (this.showall === true) {
      this.showall = false;
      this.allocationtypes.forEach(data => {
        if (data.active === 1) {
          this.allocationtypesactive.push(data);
        }
      });
      this.allocationtypes = [];
      this.allocationtypes = this.allocationtypesactive;
    } else {
      this.showall = true;
      this.allocationtypes = [];
      this.getAll();
    }
  }

  // function to get user rights
  getUserRights() {
    const btnToEnable = JSON.parse(this.actionRights);
    if (btnToEnable.length > 0) {
      this.readOnly = true;
      btnToEnable.forEach(d => {
        if (d !== undefined) {
          if (d === 2) {
            this.add = true;
          } else if (d === 3) {
            this.edit = true;
          } else if (d === 4) {
            this.delete = true;
          }
        }
      });
    }
  }

  clearForm() {
    this.allocationtypeModalRef.hide();
  }

  sort(key) {
    this.key = key;
    this.reverse = !this.reverse;
  }


  getAll() {
    this.allocationtypes = [];
    this.allocationtypesactive = [];
    this.allocationtypeservice.Get().subscribe(res => {
      if (res[0] != null && res[0] !== undefined) {
        this.allocationtypes = JSON.parse(res[0]);
        if (this.showallstatus === true) {
          this.allocationtypes.forEach(data => {
            if (data.active === 1) {
              this.allocationtypesactive.push(data);
            }
          });
          this.allocationtypes = [];
          this.allocationtypes = this.allocationtypesactive;
        }
      }
    }, error => { this.toastr.error('Error while getting data'); });

  }

  get g() { return this.allocationtypeForm.controls; }

  Post(allocationtype: AllocationType) {

    this.submitted = true;

    if ((allocationtype.allocationtype.trim() === undefined) || (allocationtype.allocationtype.trim() === '')) {
      this.toastr.error('AllocationType should not be empty');
      return;
    }

    let msg = null;

    this.userid = +localStorage.getItem('userid');
    allocationtype.allocationtype = allocationtype.allocationtype.trim();
    if (this.operation === 'add') {

      allocationtype.createdby = this.userid;
      msg = 'Record Added Successfully';
      this.allocationtypeservice.Post(allocationtype).subscribe(res => {
        if (res.status === 200) {
          if (res !== undefined) {
            if (res.body !== 0) {
              this.allocationtypeModalRef.hide();
              this.getAll();
              this.toastr.success('Data added successfully');
              this.clearForm();
            } else { this.toastr.warning('Record already exists.'); }
          }
        }
      },
        error => {
          this.toastr.error('Error while doing the operation');
          this.postresult = false;
        });
    } else if (this.operation = 'update') {
           allocationtype.updatedby = this.userid;
      msg = 'Record updated successfully';
      this.allocationtypeservice.Put(allocationtype).subscribe(res => {
        if (res.status === 200) {
          if (res !== undefined) {
            if (res.body !== 0) {
              this.allocationtypeModalRef.hide();
              this.getAll();
              this.toastr.success('Data updated successfully');
              this.clearForm();
            } else { this.toastr.warning('Record already exists.'); }
          }
        }
      },
        error => {
          this.toastr.error('Error while doing the operation');
          this.postresult = false;
        });
    }
    this.submitted = false;
  }

  ChangeActive(e) {
    if (e.currentTarget.checked) {
      this.allocationtypeForm.controls['active'].setValue(1);
    } else {
      this.allocationtypeForm.controls['active'].setValue(0);
    }
  }

  OpenConfirmTemplate(allocationtype) {
    if (allocationtype.active === 0) {
      this.confmsg = 'activate';
    } else {
      this.confmsg = 'deactivate';
    }
    this.dialogService.addDialog(CommondialogComponent,
      {
        title: 'Please Confirm',
        message: 'Are you sure you want to ' + this.confmsg + ' this record ?',
        hclass: 'modelsuccess',
        oktext: 'Yes',
        canceltext: 'No',
        okshow: true,
        cancelshow: true
      }).subscribe((isConfirmed) => {
        if (isConfirmed) {
          this.allocationtype = allocationtype;

          this.Delete();

        }

      });

  }

  Delete() {
    let msg;
    if (this.allocationtype.active === 0) {
      this.allocationtype.active = 1;
      msg = 'Record activated successfully';
    } else {
      this.allocationtype.active = 0;
      msg = 'Record deactivated successfully';
    }
    this.userid = +localStorage.getItem('userid');
    this.allocationtype.updatedby = this.userid;
    this.allocationtypeservice.Delete(this.allocationtype).subscribe(res => {
      this.toastr.success(msg);
      this.getAll();
    },
      error => { this.deleteResult = false; });

  }

  hidePopup() {
    this.allocationtypeModalRef.hide();
  }

  openAllocationTypeModal(template: TemplateRef<any>, type, allocationtype?: AllocationType) {

    this.operation = type;

    if (type === 'update') {
      this.allocationtypeForm.controls['allocationtypeid'].setValue(allocationtype.allocationtypeid);
      this.allocationtypeForm.controls['allocationtype'].setValue(allocationtype.allocationtype);
      this.allocationtypeForm.controls['active'].setValue(allocationtype.active);
      this.allocationtype = allocationtype;
    }
    if (type === 'add') {
      this.allocationtypeForm.controls['allocationtypeid'].setValue(0);
      this.allocationtypeForm.controls['allocationtype'].setValue('');
      this.allocationtypeForm.controls['active'].setValue(1);
    }
    this.allocationtypeModalRef = this.modalService.show(template, this.config);

    const aa = document.getElementsByClassName('modal-content');
    aa[0].classList.remove('modal-content');

  }

}
